# *modified "Fri Oct 16 12:53:34 2015" *by "Paul E. Black"
from ocse import site
from ocse import extractor
import re

print("Parsing files and Building AST trees, this may take a while...")
sites_extractor = extractor.Extractor("selected_Juliet_tests/", 'int_of')

print("Extracting int overflow sites...")
int_overflow_sites = sites_extractor.int_overflow_sites()

print("Generating report...")
int_overflow_bugs = []
for my_site in reversed(int_overflow_sites): # reversed() helps to remove items from the list being currently iterated

 # exclude sites containing char/short/unsigned datatypes
 if re.match(r'.*_(char|short|unsigned)_.*', my_site.filename):
  int_overflow_sites.remove(my_site)
  continue

 if(my_site.buggy == True):
   int_overflow_bugs.append(my_site)

print("generating xml files")
extractor.Extractor.to_xml(int_overflow_sites, "integer_inc_sites.xml")
print("Done.")

print "total int overflow sites: {0}".format(len(int_overflow_sites))
print "total int overflow bugs: {0}".format(len(int_overflow_bugs))
