# *created  "Thu Nov 19 11:29:43 2015" *by "Paul E. Black"
# *modified "Thu Nov 19 12:11:14 2015" *by "Paul E. Black"

# extract sites of variable reference checks

from ocse import site
from ocse import extractor

def cmp_sites(site_b, site_a):
 if site_a.filename < site_b.filename:
  return -1
 elif site_a.filename > site_b.filename:
  return 1
 else:
  if site_a.line < site_b.line:
   return -1
  elif site_a.line > site_b.line:
   return 1
  else:
   return 0

print("Parsing files and building AST trees. This may take a while...")
sites_extractor = extractor.Extractor("selected_Juliet_tests/", 'variable_access')

print("Extracting variable access sites...")
relevant_sites = sorted(sites_extractor.variable_access_sites(), cmp=cmp_sites) # Order sites, first by filename then by line number

print("Generating report...")
files_with_buggy_sites = []
buggy_sites = []
for my_site in reversed(relevant_sites):
 if my_site.buggy == True:
  # Frama-C warns only the first flaw in the file, so we'll ignore the following flaws
  if my_site.filename not in files_with_buggy_sites:
   buggy_sites.append(my_site)
   files_with_buggy_sites.append(my_site.filename)
  else:
   relevant_sites.remove(my_site)

print("generating xml file")
extractor.Extractor.to_xml(relevant_sites, "variable_ref_sites.xml")

print "total variable access sites: {0}".format(len(relevant_sites))
print "total uninitialized variable access sites: {0}".format(len(buggy_sites))

# end of get_variable_ref.py
