"""Node Visitor for division by zero sites."""

from pycparser import c_ast

class DivByZeroVisitor(c_ast.NodeVisitor):

  """pyparser NodeVisitor for division by zero sites."""

  def __init__(self):
    """Constructor method with a list to keep the nodes that matches the site
    type.
    """
    self.nodes = []

  def visit_Assignment(self, node):
    """Rules for site matching."""
    if(node.op == '/=' or node.op == '%='):
      self.nodes.append(node)
    for c_name, c in node.children():
      self.visit(c)

  def visit_BinaryOp(self, node):
    """Rules for site matching."""
    if(node.op == '/' or node.op == '%'):
      self.nodes.append(node)
    for c_name, c in node.children():
      self.visit(c)

