# *modified "Mon Oct 19 11:26:37 2015" *by "Paul E. Black"
"""Node Visitor for pointer dereference sites."""

from pycparser import c_ast

class NullPtrDerefVisitor(c_ast.NodeVisitor):

  """pyparser NodeVisitor for pointer dereference sites."""

  def __init__(self):
    """Constructor method with a list to keep the nodes that matches the site
    type.
    """
    self.nodes = []

  def visit_UnaryOp(self, node):
    """Rules for site matching."""
    if(node.op == '*'):
      self.nodes.append(node.expr)

    for c_name, c in node.children():
      self.visit(c)

  def visit_ArrayRef(self, node):
    """Rules for site matching."""
    self.nodes.append(node.name)

    for c_name, c in node.children():
      self.visit(c)

  # copied from variable_access.py 16 Oct 2015
  def visit_StructRef(self, node):
    """Rules for site matching."""
    if(node.type == '->'):
      self.nodes.append(node.name)

    for c_name, c in node.children():
      self.visit(c)

