"""Node Visitor for return sites."""

from pycparser import c_ast

class ReturnVisitor(c_ast.NodeVisitor):

  """pyparser NodeVisitor for return sites."""

  def __init__(self):
    """Constructor method with a list to keep the nodes that matches the site
    type.
    """
    self.nodes = []

  def visit_Return(self, node):
    """Rules for site matching."""
    if(node.expr and not isinstance(node.expr, c_ast.Constant)):
      self.nodes.append(node)

    for c_name, c in node.children():
      self.visit(c)

